Capítol 3. Versions de Debian

# Capítol 3. Versions de Debian

De Debian 0.01 a 0.90 (agost-desembre del 1993)

Debian 0.91 (gener del 1994): Aquesta versió tenia un sistema de paquets senzill que podia instal·lar i desinstal·lar paquets. El projecte havia crescut fins a tenir diverses dotzenes de persones en aquell moment.

Debian 0.93R5 (març del 1995): En aquest punt, la responsabilitat de cada paquet es va assignar clarament a un desenvolupador, i el gestor de paquets (dpkg) es va utilitzar per instal·lar paquets després de la instal·lació d'un sistema base.

Debian 0.93R6 (novembre del 1995): apareix dselect. Aquesta va ser l'última versió de Debian utilitzant el format binari «a.out»; hi havia uns 60 desenvolupadors. El primer servidor «master.debian.org» va ser construït per Bdale Garbee i allotjat per HP en paral·lel amb la publicació de 0.93R6. El desplegament d'un servidor mestre explícit en el qual els desenvolupadors de Debian construirien cada publicació va portar directament a la formació de la xarxa de rèpliques de Debian, i indirectament al desenvolupament de moltes de les polítiques i procediments utilitzats per gestionar el projecte avui en dia.

Debian 1.0 no es va publicar mai: InfoMagic, un venedor de CD, va enviar accidentalment una versió de desenvolupament de Debian i la va titular 1.0. L'11 de desembre del 1995, Debian i InfoMagic van anunciar conjuntament que aquest llançament havia estat una pífia. Bruce Perens explica que les dades contingudes al «InfoMagic Linux Developer's Resource 5-CD Set November 1995» com a «Debian 1.0» no és la versió 1.0 de Debian, sinó una versió de desenvolupament primerenca que només estava parcialment en format ELF, probablement no engegaria o s'executaria correctament, i no representava la qualitat d'un sistema Debian publicat. Per evitar confusions entre la versió prematura del CD i la versió real de Debian, el projecte Debian va anomenar el seva següent versió com a «Debian 1.1». El prematur Debian 1.0 en CD és obsolet i no s'hauria d'utilitzar.

L'allotjament de «master.debian.org» es va traslladar d'HP a «i-Connect.Net» cap a finals del 1995. Michael Neuffer i Shimon Shapiro, fundadors d'«i-Connect.Net», van allotjar el «master» amb el seu propi maquinari durant una mica més d'un any. Durant aquest temps, van proporcionar molts serveis a Debian, incloent-hi l'executar el que era essencialment el procés diari del New Maintainer, i ajudar significativament al creixement de la primera xarxa de rèpliques de Debian.

Debian 1.1 Buzz (17 de juny del 1996): Aquesta va ser la primera versió de Debian amb un nom en clau. Va ser agafat, com tots els altres fins ara, del nom d'un personatge d'una de les pel·lícules de Toy Story ... en aquest cas, Buzz Lightyear. En aquest moment, Bruce Perens havia assumit el lideratge del projecte d'Ian Murdock, i Bruce estava treballant a Pixar, l'empresa que produïa les pel·lícules. Aquesta versió era totalment ELF, utilitzava el nucli 2.0 de Linux i contenia 474 paquets.

Debian 1.2 Rex (12 de desembre del 1996): Anomenada com el dinosaure de plàstic de les pel·lícules de Toy Story. Aquesta versió contenia 848 paquets mantinguts per 120 desenvolupadors

Debian 1.3 Bo (5 de juny del 1997): Anomenada com Bo Peep, la pastora. Aquesta versió contenia 974 paquets mantinguts per 200 desenvolupadors.

Debian 2.0 Hamm (24 de juliol del 1998): Anomenada com el porquet guardiola de les pel·lícules de Toy Story. Aquest va ser el primer llançament multiarquitectura de Debian, afegint compatibilitat amb les arquitectures de la sèrie Motorola 68000. Amb Ian Jackson com a líder del projecte, aquesta versió va fer la transició a «libc6», i consistia en més de 1500 paquets mantinguts per més de 400 desenvolupadors.

Debian 2.1 Slink (9 de març del 1999): Anomenada així pel gos-molla de la pel·lícula. Es van afegir dues arquitectures més, Alpha i SPARC. Amb Wichert Akkerman com a cap del projecte, aquesta versió consistia en uns 2250 paquets i requeria dos CDs del conjunt oficial. La innovació tècnica clau va ser la introducció d'«apt», una nova interfície de gestió de paquets. Àmpliament emulat, l'«apt» va abordar problemes resultants del creixement continuat de Debian, i va establir un nou paradigma per a la descàrrega de paquets i la instal·lació en sistemes operatius de codi obert.

Debian 2.2 Potato (15 d'agost del 2000): Anomenada així pel «Mr Potato Head» de les pel·lícules de Toy Story. Aquesta versió va afegir compatibilitat amb les arquitectures PowerPC i ARM. Amb Wichert encara treballant com a cap del projecte, aquesta versió contenia més de 3900 paquets binaris derivats de més de 2600 paquets de codi font mantinguts per més de 450 desenvolupadors Debian.

Debian 3.0 Woody (19 de juliol del 2002): Anomenada així pel personatge principal les pel·lícules de Toy Story: el vaquer «Woody». En aquesta versió es van afegir encara més arquitectures: IA-64, HP PA-RISC, MIPS («big endian»), MIPS («little endian») i S/390. Aquesta és també la primera versió en incloure programari criptogràfic a causa de la relaxació de les restriccions d'exportació als EUA, i també el primer a incloure KDE, un cop els problemes de llicència amb Qt es van resoldre. Amb Bdale Garbee recentment nomenat Project Leader, i més de 900 desenvolupadors de Debian, aquesta versió contenia al voltant de 8.500 paquets binaris i 7 CD binaris en el conjunt oficial.

Debian 3.1 Sarge (6 de juny del 2005): anomenada així pel sergent dels Homes de l'Exèrcit de Plàstic Verd. No es van afegir noves arquitectures a la versió, encara que un port AMD64 no oficial es va publicar al mateix temps i es va distribuir a través del nou lloc d'allotjament del projecte Alioth. Aquesta versió comptava amb un nou instal·lador: debian-installer, una peça modular de programari que comptava amb detecció automàtica de maquinari, funcions d'instal·lació desatesa i que va ser publicat completament traduït a més de trenta idiomes. També va ser el primer llançament que va incloure una suite d'oficina completa: OpenOffice.org. Branden Robinson acabava de ser nomenat cap del projecte. Aquesta versió va ser realitzada per més de nou-cents desenvolupadors de Debian, i contenia al voltant de 15.400 paquets binaris i 14 CD binaris en el conjunt oficial.

Debian 4.0 Etch (8 d'abril del 2007): anomenada així per la «pissarra màgica» de la pel·lícula. En aquesta publicació es va afegir una arquitectura: AMD64, i es va eliminar el suport oficial per a m68k. Aquesta versió va continuar utilitzant el debian-installer, però afegint en aquest llançament un instal·lador gràfic, verificació criptogràfica dels paquets descarregats, un particionat més flexible (amb compatibilitat per a particions encriptades), configuració del correu simplificada, una selecció d'escriptori més flexible, localització simplificada però millorada i nous modes, incloent un mode de rescat. Les noves instal·lacions no necessitarien reiniciar-se durant el procés d'instal·lació ja que les dues fases anteriors de la instal·lació ara s'integraven. Aquest nou instal·lador va proporcionar suport per a scripts que utilitzen caràcters compostos i llenguatges complexos en la seva versió gràfica, augmentant el nombre de traduccions disponibles a més de cinquanta. Sam Hocevar va ser nomenat cap del projecte el mateix dia, i el projecte ja incloïa més de mil trenta desenvolupadors. La publicació contenia al voltant de 18.000 paquets binaris repartits en més de 20 CD binaris (3 DVDs) del conjunt oficial. També hi havia dos CD binaris disponibles per instal·lar el sistema amb entorns d'escriptori alternatius diferents del predeterminat.

Debian 5.0 Lenny (febrer del 2009): anomenada així pels binoculars amb corda de les pel·lícules de Toy Story. En aquesta versió es va afegir una arquitectura: ARM EABI (o armel), proporcionant suport per als processadors ARM més nous i fent obsolet el port ARM antic (arm). El port m68k no es va incloure en aquesta versió, tot i que encara era proporcionat a la distribució unstable. Aquesta versió no va incloure el port de FreeBSD, malgrat que s'hi havia treballat molt per fer-lo apte encara no complia els requisits d'aptitud per a aquesta versió.

La compatibilitat amb dispositius de petit factor es va incrementar en aquesta versió pel suport afegit per a la plataforma Orion de Marvell, que es va utilitzar en molts dispositius d'emmagatzematge i també va proporcionar compatibilitat amb diversos Netbooks. Es van afegir algunes noves eines de compilació que permetien que els paquets de Debian es construïssin externament («cross-built») i es reduïssin per a sistemes ARM integrats. A més, els «netbooks» de diferents venedors ara ja eren compatibles i la distribució proporcionava programari més adequat per a ordinadors amb un rendiment relativament baix.

També va ser la primera versió que va proporcionar versions lliures de la tecnologia Java de Sun, fent possible proporcionar aplicacions Java a la secció main.

Debian 6.0 Squeeze (febrer del 2011): anomenada així pels extraterrestres verds de tres ulls.

La versió es va congelar el 6 d'agost del 2010, amb molts dels desenvolupadors de Debian reunits al 10è DebConf de Nova York.

Mentre que dues arquitectures («alpha» i «hppa») van ser eliminades, dues arquitectures del nou port de FreeBSD («kfreebsd-i386» i «kfreebsd-amd64») van ser posades a disposició com a technology preview, incloent-hi el nucli i les eines d'usuari, així com el programari usual de servidor (encara que no de moment característiques avançades d'escriptori). Aquesta va ser la primera vegada que una distribució Linux s'estenia per a permetre també l'ús d'un nucli diferent del Linux.

La nova versió va introduir una seqüència d'arrencada basada en dependències, que permetia processar els scripts d'inici en paral·lel, accelerant l'inici del sistema.

Debian 6 va ser la primera versió que es va beneficiar del Long Term Support (LTS), un projecte per estendre la vida útil de totes les versions estables de Debian fins a (almenys) 5 anys. La Debian LTS no era gestionada per l'equip de seguretat de Debian, sinó per un grup separat de voluntaris i empreses interessades a fer-ne un èxit. Debian 6 va tenir suport fins a finals de febrer del 2016, però limitada a les arquitectures «i386» i «amd64».

Debian 7.0 Wheezy (maig del 2013): anomenada així pel pingüí de goma amb corbatí vermell.

La versió es va congelar el 30 de juny del 2012, molt a prop de la reunió de desenvolupadors de Debian al 12è DebConf a Managua, Nicaragua.

Una arquitectura va ser inclosa en aquesta versió («armhf»), i es va introduir el suport multi-arquitectura, que va permetre als usuaris instal·lar paquets de diferents arquitectures a la mateixa màquina. Les millores en el procés d'instal·lació van permetre a les persones amb discapacitat visual instal·lar el sistema utilitzant el programari de parla per primera vegada.

Aquesta també va ser la primera versió que va donar suport a la instal·lació i arrencada en dispositius utilitzant microprogramari UEFI.

Debian 7 va tenir suport a llarg termini (LTS) per a les arquitectures «i386», «amd64», «armel» i «armhf» fins a finals de maig del 2018.

Debian 8 Jessie (abril del 2015): anomenada així per la nina vaquera que va aparèixer per primera vegada a Toy Story 2.

Aquesta versió va introduir per primera vegada el sistema «init» de «systemd» com a predeterminat. Es van introduir dues noves arquitectures: «arm64» i «ppc64el» i se'n van treure tres: «s390» (substituïda per «s390x»), «ia64» i «sparc». L'arquitectura Sparc havia estat present a Debian durant 16 anys, però no el tenia suport de desenvolupadors per fer-la mantenible dins de la distribució.

La versió incloïa moltes millores de seguretat, com ara un nucli nou que anul·lava tot un conjunt de vulnerabilitats de seguretat (atacs d'enllaços), una nova manera de detectar paquets que tenien suport de seguretat, més paquets compilats amb opcions de compilador estrictes i un nou mecanisme («needrestart») per detectar subsistemes que s'havien de reiniciar per tal de propagar actualitzacions de seguretat després d'una actualització.

Debian 8 va tenir suport a llarg termini (LTS) per a les arquitectures «i386», «amd64», «armel» i «armhf» fins a finals de juny del 2020.

Debian 9 Stretch (juny del 2017): anomenada així pel pop de goma amb ventoses als seus vuit llargs tentacles que va aparèixer a Toy Story 3.

La versió es va congelar el 7 de febrer del 2017.

Debian 9 va ser dedicada al fundador del projecte, Ian Murdock, que va morir el 28 de desembre del 2015.

La compatibilitat amb l'arquitectura «powerpc» es va eliminar en aquesta versió, mentre que es va afegir l'arquitectura «mips64el». Aquesta versió va introduir paquets de depuració amb un repositori nou a l'arxiu; els paquets d'aquest repositori proporcionaven símbols de depuració automàticament per als paquets. El Firefox i el Thunderbird van tornar a Debian, reemplaçant les seves versions de marca blanca Iceweasel i Icedove, que van estar presents a l'arxiu durant més de 10 anys. Gràcies al projecte Reproducible Builds, més del 90% dels paquets font inclosos a Debian 9 podien generar paquets binaris idèntics bit a bit.

Debian 9 va tenir suport a llarg termini (LTS) per a arquitectures «i386», «amd64», «armel» i «armhf» fins a finals de juny del 2022.

Debian 10 Buster (juliol del 2019): anomenada així pel gos de companyia d'Andy, rebut com a regal de Nadal al final de Toy Story.

Amb aquesta versió Debian per primera vegada va incloure un marc de control d'accés obligatori habilitat per defecte (AppArmor). També va ser la primera versió de Debian que incloïa programes basats en Rust com Firefox, «ripgrep», «fd», «exa», etc. i un nombre significatiu de biblioteques basades en Rust (més de 450). A Debian 10, el GNOME per defecte utilitza el servidor de visualització Wayland en lloc de Xorg, proporcionant un disseny senzill i més modern, i beneficis de seguretat. El suport UEFI («Unified Extensible Firmware Interface») introduït per primera vegada a Debian 7 va continuar millorant-se considerablement a Debian 10, estant inclòs per a arquitectures «amd64», «i386» i «arm64» i funcionant sense retocs a la majoria de màquines amb el Secure Boot activat.

Debian 10 va tenir suport a llarg termini (LTS) per a les arquitectures «i386», «amd64», «armel» i «armhf» fins a finals de juny del 2024.

Debian 11 Bullseye (14 d'agost del 2021): anomenada així pel cavall de fusta de Woody que va aparèixer a Toy Story 2.

Aquesta versió contenia més d'11.294 paquets nous amb un total de 59.551 paquets, juntament amb una reducció significativa de més de 9.519 paquets que van ser marcats com a «obsolets» i suprimits. Es van actualitzar 42.821 paquets i 5.434 paquets es van mantenir sense canvis.

Debian 11 va permetre la impressió i l'escaneig sense la necessitat de controladors específics de fabricant (que sovint no són lliures), i va incloure un nucli Linux amb suport per al sistema de fitxers exFAT. El suport d'arquitectura «mips» va ser abandonat, però mantenint el suport per a arquitectures «mipsel» («little-endian») per a maquinari de 32 bits i arquitectura «mips64el» per a maquinari de 64 bits.

L'equip de Debian Med va participar en la lluita contra la COVID-19 empaquetant programari per investigar el virus a nivell de seqüència i per lluitar contra la pandèmia amb les eines utilitzades en epidemiologia; aquest treball va continuar centrant-se en les eines d'aprenentatge automàtic per a tots dos camps.

Debian 12 Bookworm (10 de juny del 2023): anomenada així per un cuc de joguina verd amb una llanterna incorporada que va aparèixer a Toy Story 3.

Aquesta versió contenia més d'11.089 paquets nous amb un total de 64.419 paquets, mentre que més de 6.296 paquets foren suprimits com a «obsolets». En aquesta versió es van actualitzar 43.254 paquets. L'ús global de disc de bookworm és de 365.016.420 kB (365 GB), i està format per 1.341.564.204 línies de codi.

Després de la Resolució General 2022 sobre el microprogramari no lliure, el contracte social de Debian es va ajustar i es va introduir una nova àrea d'arxiu anomenada non-free-firmware, fent possible separar el microprogramari no lliure dels altres paquets no lliures. La majoria de paquets de microprogramari no lliures s'han mogut de non-free a non-free-firmware. Aquesta separació permet construir una varietat d'imatges oficials d'instal·lació. I fa que sigui molt més fàcil la instal·lació de Debian en maquinari popular utilitzant l'instal·lador oficial de Debian.

Un total de nou arquitectures són compatibles oficialment amb bookworm.

L'equip de Debian Cloud publica bookworm per a tres serveis populars de computació al núvol.

Entre publicacions, a l'informe d'error #978636 (febrer del 2021), el Comitè Tècnic va resoldre que Debian bookworm només seria compatible amb la disposició del sistema de fitxers amb el «usr» unificat[1], deixant de banda el suport per a la disposició «non-merged-usr». Per als sistemes instal·lats amb buster o bullseye no hi hauria canvis al sistema de fitxers; no obstant això, els sistemes que utilitzessin la disposició antiga serien convertits durant l'actualització.

Gràcies al treball combinat de l'equip de seguretat de Debian i l'equip de suport a llarg termini de Debian, bookworm tindrà suport en quatre arquitectures fins al juny del 2028 (5 anys després de la publicació).

Debian 13 Trixie (la distribució testing a partir de l'agost del 2024): Trixie és un triceratop de joguina blau que va aparèixer a Toy Story 3.

[1] «usr-merge» (o «usr» fusionat o `/usr`-move) és una disposició del sistema de fitxers on els directoris tradicionals d'Unix `/bin`, `/sbin`, `/lib` i `/lib64` són reemplaçats per enllaços simbòlics als seus homòlegs sota `/usr`. Per exemple, `/bin` és reemplaçat per un enllaç simbòlic a `/usr/bin`. El 2012, l'«usr-merge» va ser implementat per Fedora Linux, així com per Ubuntu Linux. Vegeu també The Case For The Usr Merge i les Notes de publicació de Bookworm.

Capítol 2. Lideratge |  | Capítol 4. Una història detallada